<%@ Page Language="VB" runat="server" debug="true" explicit="true" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDB" %>
<script language="VB" runat="server">
 
Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs)
	If Not Page.IsPostBack Then
		viewstate("sortField") = "posted"
		viewstate("sortDirection") = "DESC"
		BindGrid()
	End If
End Sub
 
Private Sub BindGrid()
	Dim strConn as string = "Provider=Microsoft.Jet.OLEDB.4.0;" _
		& "Data Source=" & Server.MapPath("articles.mdb") & ";"
	Dim MySQL as string = "SELECT title, description, url, posted " _
		& "FROM article ORDER BY " _
		& viewstate("sortField").ToString() & " " & viewstate("sortDirection").ToString()
	Dim MyConn as New OleDBConnection(strConn)
	Dim ds as DataSet=New DataSet()
	Dim Cmd as New OleDBDataAdapter(MySQL,MyConn)
	Cmd.Fill(ds,"Articles")	
	Try
		MyDataGrid.DataSource = dS
		MyDataGrid.Databind()
	Catch e As Exception
		MyDataGrid.CurrentPageIndex = 0
	End Try
End Sub
 
Private Sub SortGrid(ByVal source As Object, ByVal e As DataGridSortCommandEventArgs)
	If e.SortExpression.ToString() = viewstate("sortField").ToString() Then
		Select Case viewstate("sortDirection").ToString()
			Case "ASC"
				viewstate("sortDirection") = "DESC"
			Case "DESC"
				viewstate("sortDirection") = "ASC"
		End Select
	Else
		viewstate("sortField") = e.SortExpression
		viewstate("sortDirection") = "DESC"
	End If
	BindGrid()
End Sub
 
Private Sub PageGrid(ByVal source As Object, ByVal e As DataGridPageChangedEventArgs)
	MyDataGrid.CurrentPageIndex = e.NewPageIndex
	BindGrid()
End Sub
 
</script>
<html>
<head>
<title>Xefteri - Online example of maintaining Sorting while Paging in an ASP.NET Datagrid</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body bgcolor="#ffffff">
<p>Clicking on the column repeatetly will switch sorting from <strong>DESC</strong> to <strong>ASC</strong> and vice versa.<br>
The sorting preference is maintained from page to page.</p>

<form runat="server" method="post">
<asp:Datagrid runat="server" 
  Id="MyDataGrid" 
  GridLines="Horizontal" 
  AutoGenerateColumns="false" 
  BorderColor="#CCCCCC" 
  CellPadding="7" 
  CellSpacing="0" 
  AllowPaging="true" 
  OnPageIndexChanged="PageGrid" 
  AllowSorting="true" 
  OnSortCommand="SortGrid" 
  BorderWidth="1" 
  PageSize="5">
  <headerstyle 
    Font-Name="Tahoma" 
    Font-Size="84%" 
    Font-Bold="true" 
    BackColor="#CCCCCC">
  </headerstyle>
  <itemstyle 
    Font-Name="Verdana" 
    Font-Size="70%" 
    VerticalAlign="top" 
    BackColor="#FFFFFF">
  </itemstyle>
  <alternatingitemstyle 
    BackColor="#FFFFFF">
  </alternatingitemstyle>
  <pagerstyle 
    Position="Top" 
    Mode="NumericPages" 
    HorizontalAlign="Center" 
    BackColor="#FFFFD9">
  </pagerstyle>
  <columns>
    <asp:TemplateColumn>
      <headertemplate>
        Title and Description
      </headertemplate>
      <ItemTemplate>
        <b><%# DataBinder.Eval(Container.DataItem, "title") %></b><br>
        <%# DataBinder.Eval(Container.DataItem, "description") %><br>
        <a href="http://www.xefteri.com<%# DataBinder.Eval(Container.DataItem, "url") %>">
        Read More...</a>
      </ItemTemplate>
    </asp:TemplateColumn>
    <asp:boundColumn 
      DataField="posted" 
      SortExpression="posted" 
      HeaderText="Posted on" 
      DataFormatString="{0:d MMM yyyy, dddd}" 
      ItemStyle-Wrap="false">
    </asp:boundColumn>
  </columns>
</asp:DataGrid>
</form>

</body>
</html>